from django.db import models
from clmainApp.models import *
# Create your models here.



# class ClinicComplaint(models.Model): 
#     clinic = models.ForeignKey(Clinic,on_delete=models.PROTECT)
#     complaint = models.ForeignKey(Complaint,on_delete=models.PROTECT)
#     created_at = models.DateTimeField(auto_now_add=True)
#     created_by = models.ForeignKey(
#         User,
#         related_name="ClinicComplaint_created_by",
#         blank=True,
#         null=True,
#         on_delete=models.PROTECT,
#     )
#     def __str__(self):
#         return "{}-{}".format(self.clinic.name,self.complaint.name)

# class ClinicTypeComplaint(models.Model): 
#     clinic_type = models.ForeignKey(ClinicType,on_delete=models.PROTECT)
#     complaint = models.ForeignKey(Complaint,on_delete=models.PROTECT)
#     created_at = models.DateTimeField(auto_now_add=True)
#     created_by = models.ForeignKey(
#         User,
#         related_name="ClinicTypeComplaint_created_by",
#         blank=True,
#         null=True,
#         on_delete=models.PROTECT,
#     )
#     def __str__(self):
#         return "{}-{}".format(self.clinic_type.name,self.complaint.name)

# class BranchCoverage(models.Model): 
#     branch = models.ForeignKey(Branch,on_delete=models.PROTECT)
#     location = models.ForeignKey(Location,on_delete=models.PROTECT)
#     created_at = models.DateTimeField(auto_now_add=True)
#     created_by = models.ForeignKey(
#         User,
#         related_name="BranchCoverage_created_by",
#         blank=True,
#         null=True,
#         on_delete=models.PROTECT,
#     )
#     def __str__(self):
#         return "{}-{}".format(self.location.name,self.branch.name)


class BranchDay(models.Model):#el 3yada  
    branch = models.ForeignKey(Branch,on_delete=models.PROTECT,related_name="BranchDay_branch",)
    day = models.ForeignKey(WeekDay,on_delete=models.PROTECT,related_name="BranchDay_day",)
    class Meta:
        unique_together = ('branch', 'day')
    def __str__(self):
        return "{}-{}".format(self.branch.name,str(self.day.name))

class BranchDaySlot(models.Model):
    branch_day = models.ForeignKey(BranchDay,on_delete=models.PROTECT,related_name="BranchDaySlot_day",)
    slot = models.ForeignKey(HourSlot,on_delete=models.PROTECT,related_name="BranchDaySlot_slot",)
    max_pt = models.IntegerField(default=0)

    class Meta:
        unique_together = ('branch_day', 'slot')
    def __str__(self):
        return "{}-{}-{}".format(self.branch_day.branch.name,self.branch_day.day.name,str(self.slot.name))

# class BDSMaxPt(models.Model):
#     bds = models.OneToOneField(BranchDaySlot,on_delete=models.PROTECT,related_name="BDSMaxPt_bds",)
#     max_pt = models.IntegerField(default=0)
#     def __str__(self):
#         return "{}-{}".format(self.bds.slot.name,str(self.max_pt))
    
# class TempBranchDay(models.Model):
#     branch = models.ForeignKey(Branch,on_delete=models.PROTECT,related_name="TempBranchDay_branch",)
#     day = models.DateField(blank=True,null=True)
#     is_active = models.BooleanField(default=True)
#     notes = models.CharField(max_length=100,blank=True,null=True)
#     created_at = models.DateTimeField(auto_now_add=True)
#     created_by = models.ForeignKey(
#         User,
#         related_name="TempBranchDay_created_by",
#         blank=True,
#         null=True,
#         on_delete=models.PROTECT,
#     )
#     class Meta:
#         unique_together = ('branch', 'day')
#     def __str__(self):
#         return "{}-{}".format(self.branch.name,str(self.day))

# class TempBranchDaySlot(models.Model):
#     branch_day = models.ForeignKey(TempBranchDay,on_delete=models.PROTECT)
#     slot = models.ForeignKey(HourSlot,on_delete=models.PROTECT)
#     max_pt = models.IntegerField(default=0)

#     class Meta:
#         unique_together = ('branch_day', 'slot')
        
# #تخص الفروع الثابتة فقط عشان بتظهر على calendar 
# class BranchExceptionalDay(models.Model):
#     branch = models.ForeignKey(Branch,on_delete=models.PROTECT,related_name="BranchExceptionalDay_branch",)
#     title = models.CharField(max_length=15,blank=True,null=True)
#     day = models.DateField(blank=True,null=True)
#     is_working_day = models.BooleanField(default=False)#radio button list[يوم عمل - يوم اجازة]
#     notes = models.CharField(max_length=100,blank=True,null=True)
#     created_at = models.DateTimeField(auto_now_add=True)
#     created_by = models.ForeignKey(
#         User,
#         related_name="BranchExceptionalDay_created_by",
#         blank=True,
#         null=True,
#         on_delete=models.PROTECT,
#     )
#     class Meta:
#         unique_together = ('branch', 'day')
#     def __str__(self):
#         return "{}-{}".format(self.branch.name,str(self.day))

# class BranchExptnDaySlot(models.Model):
#     branch_day = models.ForeignKey(BranchExceptionalDay,on_delete=models.PROTECT)
#     slot = models.ForeignKey(HourSlot,on_delete=models.PROTECT)
#     max_pt = models.IntegerField(default=0)

#     class Meta:
#         unique_together = ('branch_day', 'slot')